//+------------------------------------------------------------------+
//|                                          EGEN Random Advisor.mq4 |
//|                             Copyright  2010, EGEN Software LTD. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, EGEN Software LTD."
#property link      "http://www.metaquotes.net"

extern   bool     CloseAll    =  false;
extern   double   TakeProfit  =  0;
extern   double   StopLoss    =  0;
extern   double   Lots        =  0;
extern   int      Slippage    =  3;

bool EQ(int value1, int value2)
{
   return(value1==value2);
}

bool TOTAL(int index)
{
   return(index<OrdersTotal());
}

double INFO(int type)
{
   return(MarketInfo(Symbol(),type));
}

double MINLOT()
{
   return(INFO(MODE_MINLOT));
}

double LOTS()
{   
   if(Lots>0) return(Lots); else return(MINLOT());
}

int TREND()
{
   if(MathRand()%2>0) return(1); else return(-1);   
}

int MAGIC()
{
   return(MathRand()%PERIOD_D1);
}

void Buy()
{ 
   OrderSend(Symbol(),OP_BUY,LOTS(),Ask,Slippage,0,0,NULL,MAGIC());
}

void Sell()
{
   OrderSend(Symbol(),OP_SELL,LOTS(),Bid,Slippage,0,0,NULL,MAGIC());   
}

void CheckProfit()
{
   if(AccountProfit()<0) return;
   if(SelectOrder())
      if(TimeLocal()>OrderOpenTime()+OrderMagicNumber()*60) CloseTicket(); 
   else return;
}
   
void SendOrder() 
{   
   if(SelectOrder()) CheckProfit(); else if(TREND()<0) Sell(); else Buy();    
}              

bool SYMBOL()
{
   return(OrderSymbol()==Symbol());
}

bool SelectOrder() 
{
   for(int i=0; TOTAL(i); i++)
      if(OrderSelect(i,SELECT_BY_POS)) if(SYMBOL()) return(true);
   return(false);         
}

int ORDER()
{   
   if(EQ(OrderType(),OP_SELL))       
      return(-1); 
   if(EQ(OrderType(),OP_BUY)) 
      return(1); 
   return(0);      
}  

double PRICE()
{
   if(ORDER()>0) return(Bid);
      else 
   if(ORDER()<0) return(Ask);     
}

void CloseTicket()
{
   OrderClose(OrderTicket(),OrderLots(),PRICE(),Slippage);           
}

void CloseOrder(int index)
{  
   if(SelectOrder()) CloseTicket();
}

void CloseAll()
{
   for(int i=0; i<OrdersTotal(); i++) CloseOrder(i); 
}

bool TakeProfit()
{
   if(TakeProfit>0)
      return(AccountEquity()>TakeProfit); 
   return(false);      
}

bool StopLoss()
{
   if(StopLoss>0)
      return(AccountEquity()<StopLoss);
   return(false);      
}

void CheckTrade()
{
   if(CloseAll) 
      CloseAll(); else
   if(TakeProfit()) 
      CloseAll=true; else
   if(StopLoss()) 
      CloseAll=true; 
   else SendOrder();      
}

void init()
{
   MathSrand(TimeLocal());
}
 
void start()
{
   if(IsTradeAllowed()) CheckTrade();
}



